<?php
/***********************************************************/
/* File:   roman.numerals.php                              */
/* Author: Ian Devlin                                      */
/* Web:    http://www.iandevlin.com                        */
/*                                                         */
/* Class for converting decimal numbers to their roman     */
/* numeral equivalent.                                     */
/***********************************************************/
 
 class DecimalToRoman { 
	private $romanNumeral = array("M","CM","D","CD","C","XC","L","XL","X","IX","V","IV","I");
	private $decimalNumber = array(1000,900,500,400,100,90,50,40,10,9,5,4,1);
	private $romanValue = "";
	private $numThousands = 0;
	public $roman = "";
 	 
	/*********************************************************/
	/* getRomanInfo()                                        */
	/*********************************************************/
	private function getRomanInfo($decimalValue) {
		$this->romanValue = "";
		$this->numThousands = 0;	
		for ($i = 0; $i < count($this->romanNumeral); $i++) {
			if ($decimalValue == 0) break;
			while ($decimalValue >= $this->decimalNumber[$i]) {
				$decimalValue -= $this->decimalNumber[$i];
				$this->romanValue .= $this->romanNumeral[$i];
				if ($this->romanNumeral[$i] == 'M') $this->numThousands++;
			}
		}
		return;
	 }
	 
	/*********************************************************/
	/* convert                                               */
	/*********************************************************/
	public function convert($decimalValue) {
		// There is no Roman numeral representation for 0, and 3,888,888 is the longest number represented by Roman numerals
		if (($decimalValue == 0) || ($decimalValue <= 0 || $decimalValue > 3888888)) {
			$this->roman = $decimalValue;
			return;
		}		
		$this->getRomanInfo($decimalValue);		
		if ($this->numThousands > 4) {
			$thousandString = "";
			$lRoman = $this->romanValue;
			$lNumThousands = $this->numThousands;
			for ($j = 0; $j < $lNumThousands; $j++) $thousandString .= "M";
			$this->getRomanInfo($lNumThousands);		
			$thBase = "<span style='border-top:1px solid #000'>" . $this->romanValue . "</span>";			
			$this->roman = str_replace($thousandString, $thBase, $lRoman);		
		}
		else $this->roman = $this->romanValue;
	}
}
 ?>